﻿// PvdImportPlugin.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "PvdImportPlugin.h"
#include "XmlHelper.h"

///////////////////////////////////////////////////////////////////////////////
// Common functions for all types of plugins
///////////////////////////////////////////////////////////////////////////////

PVDIMPORTPLUGIN_API SHORT __stdcall GetType()
{
	return PLUGIN_GENIMPORT;
}

PVDIMPORTPLUGIN_API WCHAR* __stdcall GetName(int LangID)
{
	return L"PvdImportPlugin";
}

PVDIMPORTPLUGIN_API WCHAR* __stdcall GetDescription(int LangID)
{
	return L"Test import plugin";
}

PVDIMPORTPLUGIN_API DWORD __stdcall GetVersionSupported()
{
	return 0; // All
}

PVDIMPORTPLUGIN_API char* __stdcall GetPluginVersion()
{
	return "0.1.2.3";
}

PVDIMPORTPLUGIN_API bool __stdcall CheckPVDVerion(int V)
{
	return true;
}

PVDIMPORTPLUGIN_API int __stdcall GetPluginLanguage()
{
	return LANG_ENGLISH;
}

PVDIMPORTPLUGIN_API WCHAR* __stdcall GetAbout(int LangID)
{
	return L"About test plugin";
}

PVDIMPORTPLUGIN_API bool __stdcall CanConfig()
{
	return false; // No configuration dialog
}

PVDIMPORTPLUGIN_API bool __stdcall Configure(int LangID, HWND AppHandle, WCHAR* pCustomFields)
{
	return true; // OK
}

PVDIMPORTPLUGIN_API int __stdcall BeginWork()
{
	return ERR_PLUG_OK;
}

PVDIMPORTPLUGIN_API void __stdcall EndWork()
{
}

///////////////////////////////////////////////////////////////////////////////
// General import plugins
///////////////////////////////////////////////////////////////////////////////

PVDIMPORTPLUGIN_API WCHAR* __stdcall GetFilter(HWND AppHandle, int LangID, WCHAR* pCustomFields)
{
	return L"Text Files|*.txt";
}

PVDIMPORTPLUGIN_API void __stdcall Parse(HWND AppHandle, int LangID, WCHAR* pFileName, TPluginImpGenMovieCallback MovieCallback, TPluginImpGenPersonCallback HumanCallback, WCHAR* pCustomFields)
{
	// TODO: read the file specified by FileName.

	{
		CXmlHelper xml;
		xml.OpenTag( L"xml" );
		xml.OpenTag( L"movie" );
		xml.CreateTag( L"title", L"Kéz-őrület" );
		xml.CreateTag( L"url", L"http://www.imdb.com/title/tt0111161/" );
		xml.CloseTag( L"movie" );
		xml.CloseTag( L"xml" );
		MovieCallback( xml.GetString() );
	}

	{
		CXmlHelper xml;
		xml.OpenTag( L"xml" );
		xml.OpenTag( L"movie" );
		xml.CreateTag( L"title", L"The Godfather" );
		xml.CreateTag( L"url", L"http://www.imdb.com/title/tt0068646/" );
		xml.CloseTag( L"movie" );
		xml.CloseTag( L"xml" );
		MovieCallback( xml.GetString() );
	}
}